
import java.io.*;
import java.net.Socket;

/**
 * this class is to upload file for clients which connect to this client.
 * first it recieve the file name and the it start sending files to the client.
 *
 * @author Naeem Esfahani,Kamyar Rafati
 * @version 1, 0
 * @see Client
 * @see Search
 */
public class Upload extends Thread {

    /**
     * socket connected to client which is used to comminucate with client.
     */
    private Socket client;

    /**
     * the path of the sharing directory.
     */
    String path;

    /**
     * this method is used to make a new Upload object.
     *
     * @param client * socket connected to client which is used to comminucate with client.
     * @param path   the path of the sharing directory.
     */
    public Upload(Socket client, String path) {
        //initialing fields
        this.client = client;
        this.path = path;
    }

    /**
     * this is the main method of the thread which perform all the tasks.
     * first it recieve the file name and the it start sending files to the client.
     */
    public void run() {

        // making inputs and outputs from socket.
        ObjectInputStream input = null;
        ObjectOutputStream output = null;
        try {
            input = new ObjectInputStream(client.getInputStream());
            output = new ObjectOutputStream(client.getOutputStream());
        } catch (IOException e) {
            System.out.println("Client : Cannot Open Streams to Upload File");
            try {
                client.close();
            } catch (IOException e1) {
            }
            return;
        }

        try {
            //reading requested file name from server.
            String filename = (String) input.readObject();

            byte bytes [] = new byte[10000];

            //opening requested file for sending back.
            FileInputStream inputfile = new FileInputStream(path + filename);

            File file = new File(path + filename);

            //sending size of the requested file.
            output.writeObject(new Long(file.length()));
            output.reset();
            output.flush();

            int size = 0;
            //sending the bytes of the requested file.
            while ((size = inputfile.read(bytes)) != -1) {
                output.write(bytes, 0, size);
                output.reset();
            }
            output.flush();


        } catch (IOException e) {
            System.out.println("Client : Cannot Upload File");
            try {
                client.close();
            } catch (IOException e1) {
            }
            return;
        } catch (ClassNotFoundException e) {
            System.out.println("Client : Invalid Type from the other side");
            return;
        }
    }
}
