
import java.io.Serializable;
import java.net.InetAddress;
import java.util.ArrayList;

/**
 * This class is some kind of wrapper or bean that contains information
 * about request
 */
public class ResponsePacket implements Serializable {
    /**
     * The list of the matched files
     */
    private ArrayList array;

    /**
     * The Inet address of the destination
     */
    private InetAddress address;

    /**
     * Port of the client for download
     */
    private int port;

    /**
     * Port getter
     *
     * @return port of the client for download
     */
    public int getPort() {
        return port;
    }

    /**
     * Port setter
     *
     * @param port port of the client for download
     */
    public void setPort(int port) {
        this.port = port;
    }

    public ResponsePacket() {
        address = null;
        array = null;
    }

    public ResponsePacket(ArrayList array, InetAddress address, int port) {
        this.array = array;
        this.address = address;
        this.port = port;
    }

    /**
     * array getter
     *
     * @return list of the matched items
     */
    public ArrayList getArray() {
        return array;
    }

    /**
     * array setter
     *
     * @param array list of the matched items
     */
    public void setArray(ArrayList array) {
        this.array = array;
    }

    /**
     * Address getter
     *
     * @return the client address
     */
    public InetAddress getAddress() {
        return address;
    }

    /**
     * Address setter
     *
     * @param address the client address
     */
    public void setAddress(InetAddress address) {
        this.address = address;
    }

    /**
     * @see Object#toString()
     */
    public String toString() {
        return array.toString() + address.toString();
    }
}
